﻿Public Class Form1
    Dim PF As New PrivateFont(My.Resources.Musical)

    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        ListBox1.Font = PF.GetFont(14)
        Label1.Font = ListBox1.Font
        ListBox1.Items.AddRange({Chr(93), Chr(125), Chr(181), Chr(190), Chr(222), Chr(236)})
        ListBox1.SelectedIndex = 0
    End Sub

    Private Sub Form1_FormClosing(sender As Object, e As FormClosingEventArgs) Handles MyBase.FormClosing
        PF.Dispose()
    End Sub

    Private Sub RichTextBox1_MouseEnter(sender As Object, e As EventArgs) Handles RichTextBox1.MouseEnter
        Label1.Visible = True
    End Sub

    Private Sub RichTextBox1_MouseLeave(sender As Object, e As EventArgs) Handles RichTextBox1.MouseLeave
        Label1.Visible = False
    End Sub

    Private Sub RichTextBox1_MouseMove(sender As Object, e As MouseEventArgs) Handles RichTextBox1.MouseMove
        Label1.BringToFront()
        Label1.Top = e.Location.Y + RichTextBox1.Top + 20
        Label1.Left = e.Location.X + RichTextBox1.Left + 10
    End Sub
    Private Sub RichTextBox1_MouseWheel(ByVal sender As Object, ByVal e As MouseEventArgs) Handles RichTextBox1.MouseWheel
        If e.Delta < 0 Then
            If ListBox1.SelectedIndex < ListBox1.Items.Count - 1 Then
                ListBox1.SelectedIndex += 1
            Else
                ListBox1.SelectedIndex = 0
            End If
        Else
            If ListBox1.SelectedIndex > 0 Then
                ListBox1.SelectedIndex -= 1
            Else
                ListBox1.SelectedIndex = ListBox1.Items.Count - 1
            End If
        End If
        Dim mwe As HandledMouseEventArgs = DirectCast(e, HandledMouseEventArgs)
        mwe.Handled = True
    End Sub

    Private Sub ListBox1_SelectedIndexChanged(sender As Object, e As EventArgs) Handles ListBox1.SelectedIndexChanged
        Label1.Text = ListBox1.Text
    End Sub

    Private Sub RichTextBox1_MouseDown(sender As Object, e As MouseEventArgs) Handles RichTextBox1.MouseDown
        'Insert_SelectedText()
        Insert_Clipboard()
    End Sub

    Private Sub Insert_SelectedText()
        With RichTextBox1
            .SelectionLength = 0
            .SelectionFont = PF.GetFont(14)
            .SelectionColor = Color.Blue
            .SelectedText = Label1.Text
        End With
    End Sub

    Private Sub Insert_Clipboard()
        Dim s As String = "{\rtf1\ansi\ansicpg1252\deff0\nouicompat\deflang1031{\fonttbl{\f0\fnil MusicalSymbols;}}{\colortbl ;\red0\green0\blue255;}\uc1 \pard\cf1\f0\fs28 " + Label1.Text + "}"
        Clipboard.SetText(s, TextDataFormat.Rtf)
        RichTextBox1.Paste()
    End Sub
End Class

Public Class PrivateFont
    Private Declare Function AddFontMemResourceEx Lib "Gdi32.dll" (ByVal pbFont As IntPtr, ByVal cbFont As Integer, ByVal pdv As Integer, ByRef pcFonts As Integer) As IntPtr
    Private Declare Function RemoveFontMemResourceEx Lib "Gdi32.dll" (ByVal pbFont As IntPtr) As Boolean

    Dim PrivateFonts As New System.Drawing.Text.PrivateFontCollection
    Dim fh As IntPtr

    Public Sub New(source() As Byte)
        Dim fontMemPointer As IntPtr
        fontMemPointer = System.Runtime.InteropServices.Marshal.AllocCoTaskMem(source.Length)
        System.Runtime.InteropServices.Marshal.Copy(source, 0, fontMemPointer, source.Length)
        fh = AddFontMemResourceEx(fontMemPointer, source.Length, 0, 1)
        PrivateFonts.AddMemoryFont(fontMemPointer, source.Length)
        System.Runtime.InteropServices.Marshal.FreeCoTaskMem(fontMemPointer)
    End Sub

    Public Sub Dispose()
        PrivateFonts.Dispose()
        RemoveFontMemResourceEx(fh)
    End Sub

    Public Function GetFont(size As Integer) As Font
        Return New Font(PrivateFonts.Families(0), size)
    End Function
End Class